Subject: Re: linux-next: build warning after merge of the tip tree

From: Kees Cook <[email-masked]>
Date: Wed, 14 Oct 2020 16:10:05 -0700

On Thu, Oct 15, 2020 at 09:25:26AM +1100, Stephen Rothwell wrote:
> Hi Kees,
> 
> On Sun, 4 Oct 2020 19:44:52 -0700 Kees Cook <[email-masked]> wrote:
> >
> > On Sun, Oct 04, 2020 at 09:00:18PM +1100, Stephen Rothwell wrote:
> > > Hi Kees,
> > > 
> > > On Sun, 4 Oct 2020 01:27:01 -0700 Kees Cook <[email-masked]> wrote:  
> > > >
> > > > I assume CONFIG_CONSTRUCTORS is enabled for your build (it should be for  
> > > 
> > > yes, indeed.
> > >   
> > > > allmodconfig). Does this patch fix it? (I'm kind of blindly guessing
> > > > based on my understanding of where this could be coming from...)
> > > > 
> > > > 
> > > > diff --git a/include/asm-generic/vmlinux.lds.h b/include/asm-generic/vmlinux.lds.h
> > > > index e1843976754a..22f14956214a 100644
> > > > --- a/include/asm-generic/vmlinux.lds.h
> > > > +++ b/include/asm-generic/vmlinux.lds.h
> > > > @@ -701,6 +701,7 @@
> > > >  #ifdef CONFIG_CONSTRUCTORS
> > > >  #define KERNEL_CTORS()	. = ALIGN(8);			   \
> > > >  			__ctors_start = .;		   \
> > > > +			KEEP(*(SORT(.ctors.*)))		   \
> > > >  			KEEP(*(.ctors))			   \
> > > >  			KEEP(*(SORT(.init_array.*)))	   \
> > > >  			KEEP(*(.init_array))		   \  
> > > 
> > > And that makes the messages go away.  
> > 
> > Okay then! Thanks for testing. :) I'm not sure why the ppc-hosted
> > compiler generates those. Regardless, I'll send a proper patch...
> 
> I get these warnings from Linus' tree now ...

I've pinged the thread of the patch (from Oct 4th) that fixes this.
Hopefully that or this email will float to the top for an x86
maintainer. :) If it doesn't get picked up soon, I can try sending this
direct to Linus, though it makes more sense that it come through Ingo
(as he'd done the orphan tree pull request).

-- 
Kees Cook